do 4.6 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113
  1. #!/usr/bin/env bash
  2. # You may redistribute this program and/or modify it under the terms of
  3. # the GNU General Public License as published by the Free Software Foundation,
  4. # either version 3 of the License, or (at your option) any later version.
  5. #
  6. # This program is distributed in the hope that it will be useful,
  7. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  8. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  9. # GNU General Public License for more details.
  10. #
  11. # You should have received a copy of the GNU General Public License
  12. # along with this program. If not, see <http://www.gnu.org/licenses/>.
  13. [ -n "$PLATFORM" ] || PLATFORM=$(uname | tr '[:upper:]' '[:lower:]')
  14. [ -n "$MARCH" ] || MARCH=$(uname -m | sed "s/i./x/g")
  15. BUILDDIR="build_${PLATFORM}"
  16. NODE_MIN_VER="v0.8.15"
  17. hasOkNode()
  18. {
  19. for NODE in "$(pwd)/${BUILDDIR}/nodejs/node/bin/node" "nodejs" "node"; do
  20. if ${NODE} -v >/dev/null 2>&1; then
  21. ${NODE} ./node_build/versionTest.js ${NODE_MIN_VER} && return 0;
  22. echo "You have a version of node [${NODE}] but it is too old [`${NODE} -v`]"
  23. fi
  24. done
  25. return 1
  26. }
  27. getNode()
  28. {
  29. echo "Installing node.js"
  30. echo "You can bypass this step by manually installing node.js ${NODE_MIN_VER} or newer"
  31. if [ "${PLATFORM}-${MARCH}" = "linux-x86_64" ]; then
  32. NODE_DOWNLOAD="http://nodejs.org/dist/v0.10.24/node-v0.10.24-linux-x64.tar.gz"
  33. NODE_SHA="6ef93f4a5b53cdd4471786dfc488ba9977cb3944285ed233f70c508b50f0cb5f"
  34. elif [ "${PLATFORM}-${MARCH}" = "linux-x86" ]; then
  35. NODE_DOWNLOAD="http://nodejs.org/dist/v0.10.24/node-v0.10.24-linux-x86.tar.gz"
  36. NODE_SHA="fb6487e72d953451d55e28319c446151c1812ed21919168b82ab1664088ecf46"
  37. elif [ "${PLATFORM}-${MARCH}" = "linux-armv6l" ]; then #Raspberry Pi
  38. NODE_DOWNLOAD="http://nodejs.org/dist/v0.10.24/node-v0.10.24-linux-arm-pi.tar.gz"
  39. NODE_SHA="bdd5e253132c363492fa24ed9985873733a10558240fd45b0a4a15989ab8da90"
  40. elif [ "${PLATFORM}-${MARCH}" = "darwin-x86_64" ]; then
  41. NODE_DOWNLOAD="http://nodejs.org/dist/v0.10.24/node-v0.10.24-darwin-x64.tar.gz"
  42. NODE_SHA="c1c523014124a0327d71ba5d6f737a4c866a170f1749f8895482c5fa8be877b0"
  43. elif [ "${PLATFORM}-${MARCH}" = "darwin-x86" ]; then
  44. NODE_DOWNLOAD="http://nodejs.org/dist/v0.10.24/node-v0.10.24-darwin-x86.tar.gz"
  45. NODE_SHA="8b8d2bf9828804c3f8027d7d442713318814a36df12dea97dceda8f4aff42b3c"
  46. elif [ "${PLATFORM}-${MARCH}" = "sunos-x86_64" ]; then
  47. NODE_DOWNLOAD="http://nodejs.org/dist/v0.10.24/node-v0.10.24-sunos-x64.tar.gz"
  48. NODE_SHA="7cb714df92055b93a908b3b6587ca388a2884b1a9b5247c708a867516994a373"
  49. elif [ "${PLATFORM}-${MARCH}" = "sunos-x86" ]; then
  50. NODE_DOWNLOAD="http://nodejs.org/dist/v0.10.24/node-v0.10.24-sunos-x86.tar.gz"
  51. NODE_SHA="af69ab26aae42b05841c098f5d11d17e21d22d980cd32666e2db45a53ddffe34"
  52. else
  53. echo "No nodejs executable available for ${PLATFORM}-${MARCH}"
  54. echo -n "Please install nodejs (>= ${NODE_MIN_VER}) from "
  55. echo "your distribution package repository or from source."
  56. return 1
  57. fi
  58. origDir="$(pwd)"
  59. [ -d "${BUILDDIR}/nodejs" ] && rm -r "${BUILDDIR}/nodejs"
  60. mkdir -p "${BUILDDIR}/nodejs"
  61. cd "${BUILDDIR}/nodejs"
  62. if wget --version > /dev/null 2>&1; then
  63. wget -O - "${NODE_DOWNLOAD}" > node.tar.gz
  64. elif curl --version > /dev/null 2>&1; then
  65. curl "${NODE_DOWNLOAD}" > node.tar.gz
  66. else
  67. echo 'wget or curl is required download node.js but you have neither!'
  68. return 1
  69. fi
  70. if ! ( ${SHA256SUM} node.tar.gz | grep -q ${NODE_SHA} ); then
  71. echo 'The downloaded file is damaged! Aborting.'
  72. return 1
  73. fi
  74. tar -xzf node.tar.gz
  75. find ./ -mindepth 1 -maxdepth 1 -type d -exec mv {} node \;
  76. cd "$origDir"
  77. hasOkNode && return 0;
  78. return 1;
  79. }
  80. die() {
  81. echo "ERROR: $1" >&2
  82. exit 1
  83. }
  84. # get a sha256sum implementation.
  85. getsha256sum() {
  86. expected="4ee73c05d5158b0fdfec9f5e52cab3fa85b98d6992a221bbff28fdbd935e8afc"
  87. testFile=test/$expected
  88. for hasher in sha256sum gsha256sum 'shasum -a 256' 'openssl sha256'
  89. do
  90. #echo "trying ${hasher} ${testFile}"
  91. ${hasher} ${testFile} 2>/dev/null | grep -q ${expected} && SHA256SUM=${hasher} && return 0
  92. done
  93. return 1
  94. }
  95. main() {
  96. cd "$(dirname $0)" || die "failed to set directory"
  97. [ -d "${BUILDDIR}" ] || mkdir "${BUILDDIR}" || die "failed to create build dir ${BUILDDIR}"
  98. getsha256sum || die "couldn't find working sha256 hasher";
  99. hasOkNode || getNode || die "could not get working nodejs impl";
  100. $NODE ./node_build/make.js "${@}" || return 1
  101. }
  102. main